#!/usr/bin/env python
# -*- encoding: utf-8 -*-
from Tkinter import *
import tkMessageBox
import os
import shutil

class Installer(Tk):

	def status( self, status ):
		self.label.set( status )
		print status
		
	def prepare_destination_directory(self):
		if not os.path.exists( self.dest ):
			self.status( "Könyvtár létrehozása: %s" % self.dest )
			os.mkdir( self.dest )
		else:
			for root, dirs, files in os.walk( self.dest ):
				if root == self.dest:
					for d in dirs:
						self.status("Könyvtár eltávolítása: %s"% os.path.join( root, d ) )
						shutil.rmtree(os.path.join( root, d ))
					break

	def copy_files(self):
		for root, dirs, files in os.walk( self.src ):
			if root == self.src:
				for d in dirs:
					self.status( "Másolás: %s»%s" % (os.path.join( root, d ), self.dest ) )
					shutil.copytree(os.path.join( root, d ), os.path.join(self.dest, d))
				break

	def done(self):
		self.status("Kész.")
		tkMessageBox.showinfo("Telepítés", "A telepítés sikeresen befejeződött" )
		self.quit()

	def setup_info_plist(self):
		plistfile=os.path.join(self.dest, "Contents/Info.plist")
		self.status("Alkalmazásindító készítése: %s" % plistfile)
		with open(plistfile, "r") as plist:
			lines = plist.readlines()
		
		with open(plistfile, "w") as plist:
			for l in lines:
				plist.write(l.replace("bin/setup.py", "bin/easyinvoice"))

	def do_install(self):
		try:
			self.prepare_destination_directory()	
			self.copy_files()
			self.setup_info_plist()
			self.done()
		except Exception,e:
			tkMessageBox.showerror( "Telepítés", "Hiba történt a telepítés során:\n%s"% e )
			self.quit()

	def __init__( self, path ):
		Tk.__init__(self)
		self.src = os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath( path ))))
		self.dest = "/Applications/EasyInvoice.app"
		Label(self, text="Üdvözöljük az IcoNet EasyInvoice telepítőjében!\nA program telepítéséhez nyomja meg a \"Telepítés\" gombot!").pack()
		frame = Frame( self, height=2, border= 1, relief = SUNKEN )
		self.label = StringVar()
		Label( frame, text="", textvariable = self.label ).pack()
		frame.pack(padx=5, pady = 5, fill=X)
		self.install_button = Button(self, text="Telepítés", default="active", command=self.do_install)
		self.install_button.pack(side=RIGHT)
		self.exit_button = Button(self, text="Kilépés", command=self.quit)
		self.exit_button.pack(side=RIGHT)
		self.install_button.focus()
		self.title( "Számlázóprogram telepítése" )
		self.mainloop()

if __name__ == "__main__":
	Installer(sys.argv[0])

